;CD-audio 
;  
;lva()kft3,tgc5,ru
;CD_audio_player.asm
.include "8515def.inc"
;*******************
;----- -----
.def	status		=r0			;  . SREG
.def	tmp			=r16		;  
;-----   -----
.def	dmin		=r11		; 
.def	umin		=r12		;  
.def	dsec		=r13		; 
.def	usec		=r14		;
.def	statim		=r15		;  ,  0=0- ,  1=1- 
								; 2=1-  ,  3=1- ., Sleep (Power Down),
								; 5=1- (  7),  6=1- (  7),
								;80h(7)-  EEPROM,   
;-----  EEPROM-----
.def	x1			=r11		;    
.def	x2			=r12		;
.def	eeadr		=r20		; EEPROM    
.def	eeset		=r21		; EEPROM
.def	eelcd		=r22		; LCD   EEPROM
.def	xadr		=r23		;  EEPROM
;-----  -----
.def	key1		=r2			;    1
.def	key2		=r3			;    2
.def	key			=r17		; 
;-----  -----
.def	del			=r1			; 
.def	cnt			=r18		;  
.def	num			=r19		; - 
;-----  -----
.def	ref1		=r2			;3/4     
.def	ref2		=r3			;5/4     
.def	timerDU		=r8			;   (   )
.def	flloop		=r9			;  
.def	sys_ir		=r17		;"system",  (key  )
.def	com_ir		=r18		;"command",  (cnt    LCD)
.def	bitcnt		=r19		;   (num  -  LCD)
;-----   CD------
.def	highcd		=r4			;.  / CD
.def	lowcd		=r25		;.  / CD
.def	statcd		=r10		;  CD, 0=0- ,  3=1- ,  1=1-,
								;2=1-, 4=0-   , =1-  
								;7=1-  ,   , 5=1-  , 
								;6=1-    -  
.def	cdadr		=r24		;  CD
.def	p0			=r4			;     ..
.def	p1			=r5			;
.def	p2			=r6			;
.def	p3			=r7			;
;-----  B-----
.equ	PUPB0		=0b00011000	;WR  RD =1,  =0
.equ	PUPB1		=0b00111000	;RST, WR  RD =1,  =0
.equ	CD0			=00			; 170
.equ	CD1			=01			; 171
.equ	CD2			=02			; 172
.equ	CD3			=03			; 173
.equ	CD4			=04			; 174	
.equ	CD5			=05			; 175
.equ	CD6			=06			; 176
.equ	CD7			=07			; 177
.equ	CDA0		=PB0		;  CD - 0
.equ	CDA1		=PB1		;  CD - 1
.equ	CDA2		=PB2		;  CD - 2
.equ	WRCD		=PB3		;   CD
.equ	RDCD		=PB4		;   
.equ	RSTCD		=PB5		;  CD
.equ	LCDDI		=PB6		; DI 
.equ	LCDCK		=PB7		; Clk 
;-----   D-----
;.equ	rele		=PD0		;  ,  
.equ	col0		=PD3		; 0 (INT1)
.equ	col1		=PD4		; 1
.equ	col2		=PD5		; 2
.equ	row0		=PD6		; 0
.equ	row1		=PD7		; 1
.equ	intIR		=PD2		; - 0
;.equ	int1		=PD3		; - 1 (COL0)
;-----   D-----
.equ	dird1		=0b11000011	;: 1-, 0-
.equ	dird2		=0b00111011	;  (PD0-PD2 )
.equ	dird3		=0b11110011	;   
.equ	pupd0		=0b00111100	; -0,   ,  
.equ	pupd1		=0b00111101	; -0,   ,  
.equ	pupd2		=0b11000101	;  (PD0-PD2 ),  
.equ	pupd3		=0b00001111	; .,  ,   0
;*********************
;-----   EEPROM-----
.eseg							; EEPROM
.org	0						;  
altkey:			.db	0			;  , 0=, 1=
keycodes:		.db	18,19,9,12,4,13,8,2	;0= 
altkeycodes:	.db	15,18,7,30,4,31,6,2	; .  
DUstat:			.db	1			;0= , 1= 
DUsysadr:		.db	0			;  , 0=TV, 20(14h)=CD, 5-0-31(1Fh)
del_ir:			.db 90			; 64  T0   0-255 ( 4 256-32=224)
autoon:			.db	1			;, 0=, 1=
autoplay:		.db	1			;, 0=, 1=
autooff:		.db	3			; ,  
autooffind:		.db	2			;     ,  
numwrk:			.db	0			;   . 2(0-3)
numind:			.db	0			; , 2(0-3)
step_stat:		.db	3			;/    . , 2(0-3)
del_step:		.db 55			;      0-255
progvolume:		.db	127			;  CD-  
CDnumber:		.db	3			;  - CD- 0-3 
CDspeed:		.db 8			;   CD  "x" -? 0-31
CDobzor:		.db	7			;         0-31
resonator:		.dw	4000		;  
delay2:			.dw	3906		;h0F42 1, 1  4.000,   
delay1:			.dw	976			;0.25, 4,   ,   1, 976($3D0)=4/0.25, 488=8/0.125
delay0:			.db	16			;  max=255
lp0:			.db	5			;  "del",  1  Clk (>1)
lp1:			.db	10			;-----------, --------- 0  Clk (>2)
lp2:			.db	25			;-----------,   (>5)
.org	$40						;    
;-----pdu_line:	.byte 64	64   -----
				.db 20,21,22,23,24,25,26,27,28,29 ;10  
com10:		.db 0	com11:		.db 0	com12:		.db 1	com13:		.db 0
com14:		.db 0	com15:		.db 17	com16:		.db 30	com17:		.db 31
com18:		.db 0	com19:		.db 0	com20:		.db 0	com21:		.db 0
com22:		.db 0	com23:		.db 0	com24:		.db 0	com25:		.db 0
com26:		.db 0	com27:		.db 0	com28:		.db 0	com29:		.db 0
com30:		.db 0	com31:		.db 0	com32:		.db 6	com33:		.db 7
com34:		.db 0	com35:		.db 0	com36:		.db 0	com37:		.db 0
com38:		.db 0	com39:		.db 0	com40:		.db 0	com41:		.db 0
com42:		.db 0	com43:		.db 0	com44:		.db 0	com45:		.db 3
com46:		.db 0	com47:		.db 0	com48:		.db 5	com49:		.db 0
com50:		.db 13	com51:		.db 12	com52:		.db 0	com53:		.db 4
com54:		.db 2	com55:		.db 0	com56:		.db 0	com57:		.db 0
com58:		.db 0	com59:		.db 0	com60:		.db 0	com61:		.db 0
com62:		.db 0	com63:		.db 0
;****************************************************************************
;-----      -----
.dseg							; 
.org	$60						;   ( )
keycode:		.byte 1			;1   
;-----      -----
.dseg							; 
.org	$61						;   (    )
ADRLCD:			.byte 10		;10  
.org	$71	
outline:		.byte 10		;10  
;---------------------
;-----       (    EEPROM)-----
;----------
.equ	fprg	=$61			;  "P"   "F"
.equ	dnumprg	=$62			;   , 
.equ	enumprg	=$63			;   , 
.equ	fl_loop	=$64			;   RC5
.equ	ddef1	=$66			;  RC5
.equ	edef1	=$67			;  RC5
.equ	tdef	=$67			;
.equ	sdef	=$68			;
.equ	ddef	=$69			;
.equ	edef	=$6A			;
;----------------------
.dseg							; 
.org	$6B						;   ( )
h2def:			.byte 1			; 2- 
h1def:			.byte 1			; 1- 
h0def:			.byte 1			;    EEPROM
testEE0:		.byte 1			;  EEPROM, 1- 
testEE1:		.byte 1			;2- 
.org	$7B						;     
maltkey:		.byte 1			;  , 0=, 1=
mautooff:		.byte 1			; ,  
mautooffind:	.byte 1			;     ,  
mdeldr:			.byte 1			; 
mlp0:			.byte 1			;   EEPROM    ,  "del"
mlp1:			.byte 1			;
mlp2:			.byte 1			;
mtimlcdH:		.byte 1			;  -  
mtimlcdL:		.byte 1			;  -  
mdel_ir:		.byte 1			; 64  T0
mDUstat:		.byte 1			;0= , 1= 
mDUsysadr:		.byte 1			;  
mDUloop:		.byte 1			;   
mdel_step:		.byte 1			;   
mCDspeed:		.byte 2			;  
mCDobzor:		.byte 1			;   
mprogvolume:	.byte 1			;  CD-
mnumwrk:		.byte 1			; 
mnumind:		.byte 1			; 
;---------------------
.dseg
.org	$90
commandCD:		.byte12			;  -
howCD:			.byte1			;- CD
workCD:			.byte1			; CD,    
statmasterCD:	.byte1			;  CD
statslaveCD:	.byte1			;  CD
errorcodeCD:	.byte4			; CD,  
buflenCD:		.byte2			;  
;-----  -----
currenttrack:	.byte1			;  
quantitrack:	.byte1			;  
maskcounter:	.byte1			;  
masktrack:		.byte1			;  
;-----  -----
onoffcounter:	.byte1			;/ ,   .
savecounter:	.byte1			;  /4
;---------------------------------
readbufferCD:	.byte32			;     CD
readTOC_1CD_wrktr:	.byte20		;   .  1CD
readTOC_2CD_wrktr:	.byte20		;   .  2CD
readTOC_1CD_endtr:	.byte10		;   1CD
readTOC_2CD_endtr:	.byte10		;   2CD
readbuffer_volCD:	.byte24		;     CD
;---------------------------------
;.org	RAMEND-32
;stack:			.byte32			;  32
;*********************
;----------
.cseg							; 
.org	0						;  $000
	rjmp	init				;  
	rjmp	ir_rc5				;INT0,  IR 
	rjmp	keyb				;INT1,    
	reti						;CAPT TIMER1
	rjmp	tim_off				; A TIMER1 
	rjmp	outlcd				; B TIMER1
	reti						;OVF TIMER1
;-------------------------------
;*******************************
.include	"init.asm"
.include	"keyb.asm"
.include	"ir_rc5.asm"
.include	"eeprom_save.asm"
.include	"timer_off.asm"
.include	"voice_vol.asm"
.include	"initcd.asm"
.include	"ind_toc_atapi.asm"
.include	"command_cd.asm"
.include	"set_read_position.asm"
;*******************************
;-------------------------------